/*
 * Copyright (c) 2017 Adrian Siekierka
 *
 * This file is part of Unlimited Chisel Works.
 *
 * Unlimited Chisel Works is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Unlimited Chisel Works is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Unlimited Chisel Works.  If not, see <http://www.gnu.org/licenses/>.
 */

package pl.asie.ucw;

import net.minecraft.block.Block;
import net.minecraft.block.state.IBlockState;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.Item;
import net.minecraft.item.ItemBlock;
import net.minecraft.item.ItemStack;
import net.minecraft.util.NonNullList;
import net.minecraft.world.World;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import javax.annotation.Nullable;
import java.util.ArrayList;
import java.util.List;

public class ItemUCWProxy extends ItemBlock implements IUCWItem {
	private UCWBlockRule rule;
	private IBlockState base;

	public ItemUCWProxy(Block block) {
		super(block);
		rule = UCWObjectBroker.get().getRule();
		base = UCWObjectBroker.get().getBase();
		func_77627_a(true);
	}

	@Override
	@SideOnly(Side.CLIENT)
	public void func_77624_a(ItemStack stack, EntityPlayer playerIn, List<String> tooltip, boolean flagIn) {
		getItemThrough().func_77624_a(
				UCWUtils.copyChangeItem(stack, getItemThrough()),
				playerIn, tooltip, flagIn
		);
	}

	@Override
	public String func_77658_a() {
		return getItemFrom().func_77658_a();
	}

	@Override
	public String func_77667_c(ItemStack stack) {
		try {
			return getItemFrom().func_77667_c(new ItemStack(base.func_177230_c().func_180660_a(base, UnlimitedChiselWorks.RAND, 0), 1, base.func_177230_c().func_180651_a(base)));
		} catch (Exception e) {
			e.printStackTrace();
			return func_77658_a();
		}
	}
	@Override
	public String func_77653_i(ItemStack stack) {
		try {
			return getItemFrom().func_77653_i(new ItemStack(base.func_177230_c().func_180660_a(base, UnlimitedChiselWorks.RAND, 0), 1, base.func_177230_c().func_180651_a(base)));
		} catch (Exception e) {
			e.printStackTrace();
			return func_77658_a();
		}
	}

	private Item getItemFrom() {
		return Item.func_150898_a(rule.fromBlock);
	}

	private Item getItemThrough() {
		return Item.func_150898_a(rule.throughBlock);
	}

	@Override
	public int func_77647_b(int damage) {
		if (rule.through.get(damage) != null) {
			return damage;
		} else {
			return 0;
		}
	}

	@Override
	public void func_150895_a(Item item, CreativeTabs tab, NonNullList<ItemStack> items) {
		Item origItem = getItemThrough();
		NonNullList<ItemStack> proxyList = NonNullList.func_191196_a();
		origItem.func_150895_a(origItem, tab, proxyList);
		for (ItemStack stack : proxyList) {
			if (stack.func_77973_b() == origItem) {
				// FIXME: Dirt#9 doesn't really work well :-(
				if (rule.throughBlock.getRegistryName().toString().equals("chisel:dirt") && stack.func_77952_i() == 9) {
					continue;
				}

				items.add(UCWUtils.copyChangeItem(stack, item));
			}
		}
	}

	@Override
	public void getSubItemsServer(CreativeTabs tab, NonNullList<ItemStack> items) {
		for (int i = 0; i < 16; i++) {
			if (rule.through.get(i) != null) {
				// FIXME: Dirt#9 doesn't really work well :-(
				if (rule.throughBlock.getRegistryName().toString().equals("chisel:dirt") && i == 9) {
					continue;
				}

				items.add(new ItemStack(this, 1, i));
			}
		}
	}
}
