/*
 * Copyright (c) 2017 Adrian Siekierka
 *
 * This file is part of Unlimited Chisel Works.
 *
 * Unlimited Chisel Works is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Unlimited Chisel Works is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Unlimited Chisel Works.  If not, see <http://www.gnu.org/licenses/>.
 */

package pl.asie.ucw;

import net.minecraft.block.state.IBlockState;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.WorldType;
import net.minecraft.world.biome.Biome;

import javax.annotation.Nullable;

public class UCWBlockAccess implements IBlockAccess {
	private final IBlockAccess parent;

	public UCWBlockAccess(IBlockAccess parent) {
		this.parent = parent;
	}

	@Nullable
	@Override
	public TileEntity func_175625_s(BlockPos pos) {
		return parent.func_175625_s(pos);
	}

	@Override
	public int func_175626_b(BlockPos pos, int lightValue) {
		return parent.func_175626_b(pos, lightValue);
	}

	@Override
	public IBlockState func_180495_p(BlockPos pos) {
		IBlockState state = parent.func_180495_p(pos);
		if (state.func_177230_c() instanceof IUCWBlock) {
			return ((IUCWBlock) state.func_177230_c()).getBaseState();
		} else {
			return state;
		}
	}

	@Override
	public boolean func_175623_d(BlockPos pos) {
		return parent.func_175623_d(pos);
	}

	@Override
	public Biome func_180494_b(BlockPos pos) {
		return parent.func_180494_b(pos);
	}

	@Override
	public int func_175627_a(BlockPos pos, EnumFacing direction) {
		return parent.func_175627_a(pos, direction);
	}

	@Override
	public WorldType func_175624_G() {
		return parent.func_175624_G();
	}

	@Override
	public boolean isSideSolid(BlockPos pos, EnumFacing side, boolean _default) {
		return parent.isSideSolid(pos, side, _default);
	}
}
